better invocation documentation
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
49114fd4 5## Copyright (C) 2001-2011 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
c84bdaf6
LC
36
37VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
38
61cd9dc9
LC
39# You can override this variable in cfg.mk to set your own regexp
40# matching files to ignore.
41VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
42
43# This is to preprocess robustly the output of $(VC_LIST), so that even
44# when $(srcdir) is a pathological name like "....", the leading sed command
45# removes only the intended prefix.
46_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
47
48# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49# when $(srcdir) is not ".".
50ifeq ($(srcdir),.)
51_prepend_srcdir_prefix =
52else
53_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54endif
55
56# In order to be able to consistently filter "."-relative names,
57# (i.e., with no $(srcdir) prefix), this definition is careful to
58# remove any $(srcdir) prefix, and to restore what it removes.
dd7d0148
LC
59_sc_excl = \
60 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
c84bdaf6 61VC_LIST_EXCEPT = \
61cd9dc9
LC
62 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
63 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
64 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
dd7d0148 65 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
61cd9dc9 66 $(_prepend_srcdir_prefix)
c84bdaf6
LC
67
68ifeq ($(origin prev_version_file), undefined)
69 prev_version_file = $(srcdir)/.prev-version
70endif
71
72PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
73VERSION_REGEXP = $(subst .,\.,$(VERSION))
74PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
75
76ifeq ($(VC),$(GIT))
77this-vc-tag = v$(VERSION)
78this-vc-tag-regexp = v$(VERSION_REGEXP)
79else
80tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
81tag-this-version = $(subst .,_,$(VERSION))
82this-vc-tag = $(tag-package)-$(tag-this-version)
83this-vc-tag-regexp = $(this-vc-tag)
84endif
85my_distdir = $(PACKAGE)-$(VERSION)
86
87# Old releases are stored here.
88release_archive_dir ?= ../release
89
414e4441
LC
90# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
91# Use alpha.gnu.org for alpha and beta releases.
92# Use ftp.gnu.org for stable releases.
93gnu_ftp_host-alpha = alpha.gnu.org
94gnu_ftp_host-beta = alpha.gnu.org
95gnu_ftp_host-stable = ftp.gnu.org
96gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
97
98ifeq ($(gnu_rel_host),ftp.gnu.org)
99url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
100else
101url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
102endif
103
1cd4fffc
LC
104# Override this in cfg.mk if you are using a different format in your
105# NEWS file.
106today = $(shell date +%Y-%m-%d)
9157d901
LC
107
108# Select which lines of NEWS are searched for $(news-check-regexp).
109# This is a sed line number spec. The default says that we search
110# lines 1..10 of NEWS for $(news-check-regexp).
111# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
112news-check-lines-spec ?= 1,10
1cd4fffc
LC
113news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
114
c84bdaf6
LC
115# Prevent programs like 'sort' from considering distinct strings to be equal.
116# Doing it here saves us from having to set LC_ALL elsewhere in this file.
117export LC_ALL = C
118
119## --------------- ##
120## Sanity checks. ##
121## --------------- ##
122
123_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
124
125# Collect the names of rules starting with `sc_'.
126syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
127 $(srcdir)/$(ME) $(_cfg_mk)))
128.PHONY: $(syntax-check-rules)
129
dd36ce77
MW
130ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
131local-checks-available += $(syntax-check-rules)
132else
133local-checks-available += no-vc-detected
134no-vc-detected:
135 @echo "No version control files detected; skipping syntax check"
136endif
c84bdaf6
LC
137.PHONY: $(local-checks-available)
138
139# Arrange to print the name of each syntax-checking rule just before running it.
140$(syntax-check-rules): %: %.m
dde9c5a4
LC
141sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
142.PHONY: $(sc_m_rules_)
143$(sc_m_rules_):
c84bdaf6 144 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
145 @date +%s.%N > .sc-start-$(basename $@)
146
147# Compute and print the elapsed time for each syntax-check rule.
148sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
149.PHONY: $(sc_z_rules_)
150$(sc_z_rules_): %.z: %
151 @end=$$(date +%s.%N); \
152 start=$$(cat .sc-start-$*); \
153 rm -f .sc-start-$*; \
154 awk -v s=$$start -v e=$$end \
155 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
156
157# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
158# that computes and prints elapsed time.
159local-check := \
160 $(patsubst sc_%, sc_%.z, \
161 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
162
163syntax-check: $(local-check)
a927b6c1
LC
164
165# _sc_search_regexp
166#
167# This macro searches for a given construct in the selected files and
168# then takes some action.
169#
170# Parameters (shell variables):
171#
172# prohibit | require
173#
174# Regular expression (ERE) denoting either a forbidden construct
175# or a required construct. Those arguments are exclusive.
176#
177# in_vc_files | in_files
178#
179# grep-E-style regexp denoting the files to check. If no files
180# are specified the default are all the files that are under
181# version control.
182#
183# containing | non_containing
184#
185# Select the files (non) containing strings matching this regexp.
186# If both arguments are specified then CONTAINING takes
187# precedence.
188#
189# with_grep_options
190#
191# Extra options for grep.
192#
193# ignore_case
194#
195# Ignore case.
196#
197# halt
198#
199# Message to display before to halting execution.
dd7d0148
LC
200#
201# Finally, you may exempt files based on an ERE matching file names.
202# For example, to exempt from the sc_space_tab check all files with the
203# .diff suffix, set this Make variable:
204#
205# exclude_file_name_regexp--sc_space_tab = \.diff$
206#
207# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
208# when filtering by name via in_files, we explicitly filter out matching
209# names here as well.
a927b6c1
LC
210
211# By default, _sc_search_regexp does not ignore case.
c84bdaf6 212export ignore_case =
a927b6c1 213_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 214
a927b6c1
LC
215define _sc_say_and_exit
216 dummy=; : so we do not need a semicolon before each use; \
217 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
218endef
219
220# _sc_search_regexp used to be named _prohibit_regexp. However,
221# upgrading to the new definition and leaving the old name undefined
222# would usually convert each custom rule using $(_prohibit_regexp)
223# (usually defined in cfg.mk) into a no-op. This definition ensures
224# that people know right away if they're still using the old name.
225# FIXME: remove in 2012.
226_prohibit_regexp = \
227 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
228
229define _sc_search_regexp
230 dummy=; : so we do not need a semicolon before each use; \
231 \
232 : Check arguments; \
233 test -n "$$prohibit" && test -n "$$require" \
234 && { msg='Cannot specify both prohibit and require' \
235 $(_sc_say_and_exit) } || :; \
236 test -z "$$prohibit" && test -z "$$require" \
237 && { msg='Should specify either prohibit or require' \
238 $(_sc_say_and_exit) } || :; \
239 test -n "$$in_vc_files" && test -n "$$in_files" \
240 && { msg='Cannot specify both in_vc_files and in_files' \
241 $(_sc_say_and_exit) } || :; \
242 test "x$$halt" != x \
243 || { msg='halt not defined' $(_sc_say_and_exit) }; \
244 \
245 : Filter by file name; \
246 if test -n "$$in_files"; then \
dd7d0148
LC
247 files=$$(find $(srcdir) | grep -E "$$in_files" \
248 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
a927b6c1
LC
249 else \
250 files=$$($(VC_LIST_EXCEPT)); \
251 if test -n "$$in_vc_files"; then \
252 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
253 fi; \
254 fi; \
255 \
256 : Filter by content; \
257 test -n "$$files" && test -n "$$containing" \
258 && { files=$$(grep -l "$$containing" $$files); } || :; \
259 test -n "$$files" && test -n "$$non_containing" \
260 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
261 \
262 : Check for the construct; \
263 if test -n "$$files"; then \
264 if test -n "$$prohibit"; then \
265 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
266 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
267 else \
268 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
269 | grep . \
270 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
271 fi \
272 else :; \
273 fi || :;
c84bdaf6
LC
274endef
275
276sc_avoid_if_before_free:
277 @$(build_aux)/useless-if-before-free \
278 $(useless_free_options) \
279 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
280 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
281 exit 1; } || :
282
283sc_cast_of_argument_to_free:
a927b6c1
LC
284 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
285 $(_sc_search_regexp)
c84bdaf6
LC
286
287sc_cast_of_x_alloc_return_value:
a927b6c1
LC
288 @prohibit='\*\) *x(m|c|re)alloc\>' \
289 halt='don'\''t cast x*alloc return value' \
290 $(_sc_search_regexp)
c84bdaf6
LC
291
292sc_cast_of_alloca_return_value:
a927b6c1
LC
293 @prohibit='\*\) *alloca\>' \
294 halt='don'\''t cast alloca return value' \
295 $(_sc_search_regexp)
c84bdaf6
LC
296
297sc_space_tab:
a927b6c1
LC
298 @prohibit='[ ] ' \
299 halt='found SPACE-TAB sequence; remove the SPACE' \
300 $(_sc_search_regexp)
c84bdaf6
LC
301
302# Don't use *scanf or the old ato* functions in `real' code.
303# They provide no error checking mechanism.
304# Instead, use strto* functions.
305sc_prohibit_atoi_atof:
a927b6c1
LC
306 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
307 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
308 $(_sc_search_regexp)
c84bdaf6
LC
309
310# Use STREQ rather than comparing strcmp == 0, or != 0.
311sc_prohibit_strcmp:
49114fd4 312 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
c84bdaf6 313 $$($(VC_LIST_EXCEPT)) \
49114fd4
LC
314 | grep -vE ':# *define STRN?EQ\(' && \
315 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
c84bdaf6
LC
316 1>&2; exit 1; } || :
317
318# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
319# Convert all uses automatically, via these two commands:
320# git grep -l '\<exit *(1)' \
321# | grep -vEf .x-sc_prohibit_magic_number_exit \
322# | xargs --no-run-if-empty \
323# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
324# git grep -l '\<exit *(0)' \
325# | grep -vEf .x-sc_prohibit_magic_number_exit \
326# | xargs --no-run-if-empty \
327# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 328sc_prohibit_magic_number_exit:
a927b6c1
LC
329 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
330 halt='use EXIT_* values rather than magic number' \
331 $(_sc_search_regexp)
c84bdaf6
LC
332
333# Using EXIT_SUCCESS as the first argument to error is misleading,
334# since when that parameter is 0, error does not exit. Use `0' instead.
335sc_error_exit_success:
a927b6c1
LC
336 @prohibit='error *\(EXIT_SUCCESS,' \
337 in_vc_files='\.[chly]$$' \
338 halt='found error (EXIT_SUCCESS' \
339 $(_sc_search_regexp)
c84bdaf6
LC
340
341# `FATAL:' should be fully upper-cased in error messages
342# `WARNING:' should be fully upper-cased, or fully lower-cased
343sc_error_message_warn_fatal:
a927b6c1 344 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
345 | grep -E '"Warning|"Fatal|"fatal' && \
346 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
347 exit 1; } || :
348
349# Error messages should not start with a capital letter
350sc_error_message_uppercase:
a927b6c1 351 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
352 | grep -E '"[A-Z]' \
353 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
354 { echo '$(ME): found capitalized error message' 1>&2; \
355 exit 1; } || :
356
357# Error messages should not end with a period
358sc_error_message_period:
a927b6c1 359 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
360 | grep -E '[^."]\."' && \
361 { echo '$(ME): found error message ending in period' 1>&2; \
362 exit 1; } || :
363
364sc_file_system:
a927b6c1
LC
365 @prohibit=file''system \
366 ignore_case=1 \
367 halt='found use of "file''system"; spell it "file system"' \
368 $(_sc_search_regexp)
c84bdaf6
LC
369
370# Don't use cpp tests of this symbol. All code assumes config.h is included.
371sc_prohibit_have_config_h:
a927b6c1
LC
372 @prohibit='^# *if.*HAVE''_CONFIG_H' \
373 halt='found use of HAVE''_CONFIG_H; remove' \
374 $(_sc_search_regexp)
c84bdaf6
LC
375
376# Nearly all .c files must include <config.h>. However, we also permit this
377# via inclusion of a package-specific header, if cfg.mk specified one.
378# config_h_header must be suitable for grep -E.
379config_h_header ?= <config\.h>
380sc_require_config_h:
a927b6c1
LC
381 @require='^# *include $(config_h_header)' \
382 in_vc_files='\.c$$' \
383 halt='the above files do not include <config.h>' \
384 $(_sc_search_regexp)
c84bdaf6
LC
385
386# You must include <config.h> before including any other header file.
387# This can possibly be via a package-specific header, if given by cfg.mk.
388sc_require_config_h_first:
389 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
390 fail=0; \
391 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
392 grep '^# *include\>' $$i | sed 1q \
393 | grep -E '^# *include $(config_h_header)' > /dev/null \
394 || { echo $$i; fail=1; }; \
395 done; \
396 test $$fail = 1 && \
397 { echo '$(ME): the above files include some other header' \
398 'before <config.h>' 1>&2; exit 1; } || :; \
399 else :; \
400 fi
401
402sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
403 @prohibit='\bHAVE_MBRTOWC\b' \
404 halt="do not use $$prohibit; it is always defined" \
405 $(_sc_search_regexp)
c84bdaf6
LC
406
407# To use this "command" macro, you must first define two shell variables:
408# h: the header, enclosed in <> or ""
409# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 410define _sc_header_without_use
c84bdaf6
LC
411 dummy=; : so we do not need a semicolon before each use; \
412 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
413 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
414 files=$$(grep -l '^# *include '"$$h_esc" \
415 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
416 grep -LE "$$re" $$files | grep . && \
417 { echo "$(ME): the above files include $$h but don't use it" \
418 1>&2; exit 1; } || :; \
419 else :; \
420 fi
421endef
422
423# Prohibit the inclusion of assert.h without an actual use of assert.
424sc_prohibit_assert_without_use:
a927b6c1 425 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
426
427# Prohibit the inclusion of close-stream.h without an actual use.
428sc_prohibit_close_stream_without_use:
a927b6c1 429 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
430
431# Prohibit the inclusion of getopt.h without an actual use.
432sc_prohibit_getopt_without_use:
a927b6c1 433 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
434
435# Don't include quotearg.h unless you use one of its functions.
436sc_prohibit_quotearg_without_use:
a927b6c1 437 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
438
439# Don't include quote.h unless you use one of its functions.
440sc_prohibit_quote_without_use:
a927b6c1 441 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
442
443# Don't include this header unless you use one of its functions.
444sc_prohibit_long_options_without_use:
445 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 446 $(_sc_header_without_use)
c84bdaf6
LC
447
448# Don't include this header unless you use one of its functions.
449sc_prohibit_inttostr_without_use:
450 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 451 $(_sc_header_without_use)
c84bdaf6 452
61cd9dc9
LC
453# Don't include this header unless you use one of its functions.
454sc_prohibit_ignore_value_without_use:
455 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 456 $(_sc_header_without_use)
61cd9dc9 457
c84bdaf6
LC
458# Don't include this header unless you use one of its functions.
459sc_prohibit_error_without_use:
460 @h='"error.h"' \
461 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 462 $(_sc_header_without_use)
c84bdaf6
LC
463
464# Don't include xalloc.h unless you use one of its functions.
465# Consider these symbols:
466# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 467# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
468# Divide into two sets on case, and filter each through this:
469# | sort | perl -MRegexp::Assemble -le \
470# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
471# Note this was produced by the above:
61cd9dc9
LC
472# _xa1 = \
473#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
474# But we can do better, in at least two ways:
475# 1) take advantage of two "dup"-suffixed strings:
476# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
477# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
478# "char|[cmz]"
479# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
480_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
481_xa2 = X([CZ]|N?M)ALLOC
482sc_prohibit_xalloc_without_use:
483 @h='"xalloc.h"' \
484 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 485 $(_sc_header_without_use)
c84bdaf6 486
dde9c5a4 487# Extract function names:
a927b6c1 488# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
489_hash_re = \
490clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
491_hash_fn = \<($(_hash_re)) *\(
492_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
493sc_prohibit_hash_without_use:
494 @h='"hash.h"' \
495 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 496 $(_sc_header_without_use)
dde9c5a4 497
3d458a81
AW
498sc_prohibit_cloexec_without_use:
499 @h='"cloexec.h"' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
500 $(_sc_header_without_use)
501
502sc_prohibit_posixver_without_use:
503 @h='"posixver.h"' re='\<posix2_version *\(' $(_sc_header_without_use)
504
505sc_prohibit_same_without_use:
506 @h='"same.h"' re='\<same_name *\(' $(_sc_header_without_use)
507
dde9c5a4
LC
508sc_prohibit_hash_pjw_without_use:
509 @h='"hash-pjw.h"' \
510 re='\<hash_pjw *\(' \
a927b6c1 511 $(_sc_header_without_use)
dde9c5a4 512
c84bdaf6
LC
513sc_prohibit_safe_read_without_use:
514 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 515 $(_sc_header_without_use)
c84bdaf6
LC
516
517sc_prohibit_argmatch_without_use:
518 @h='"argmatch.h"' \
519 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 520 $(_sc_header_without_use)
c84bdaf6
LC
521
522sc_prohibit_canonicalize_without_use:
523 @h='"canonicalize.h"' \
524 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 525 $(_sc_header_without_use)
c84bdaf6
LC
526
527sc_prohibit_root_dev_ino_without_use:
528 @h='"root-dev-ino.h"' \
529 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 530 $(_sc_header_without_use)
c84bdaf6
LC
531
532sc_prohibit_openat_without_use:
533 @h='"openat.h"' \
534 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 535 $(_sc_header_without_use)
c84bdaf6
LC
536
537# Prohibit the inclusion of c-ctype.h without an actual use.
538ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
539|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
540sc_prohibit_c_ctype_without_use:
a927b6c1
LC
541 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
542 $(_sc_header_without_use)
c84bdaf6
LC
543
544_empty =
545_sp = $(_empty) $(_empty)
546# The following list was generated by running:
547# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
548# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
549_sig_functions = \
550 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
551 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
552 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
553 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
554_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
555# The following were extracted from "man signal.h" manually.
556_sig_types_and_consts = \
557 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
558 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
559 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
560 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
561 sigstack sigval stack_t ucontext_t
562# generated via this:
563# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
564_sig_names = \
565 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
566 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
567 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
568 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
569 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
570 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
571 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
572 SIGXCPU SIGXFSZ
573_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
574
575# Prohibit the inclusion of signal.h without an actual use.
576sc_prohibit_signal_without_use:
577 @h='<signal.h>' \
578 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
579 $(_sc_header_without_use)
580
3d458a81
AW
581# Don't include stdio--.h unless you use one of its functions.
582sc_prohibit_stdio--_without_use:
583 @h='"stdio--.h"' re='\<((f(re)?|p)open|tmpfile) *\(' \
584 $(_sc_header_without_use)
585
586# Don't include stdio-safer.h unless you use one of its functions.
587sc_prohibit_stdio-safer_without_use:
588 @h='"stdio-safer.h"' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
589 $(_sc_header_without_use)
590
a927b6c1
LC
591# Prohibit the inclusion of strings.h without a sensible use.
592# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
593sc_prohibit_strings_without_use:
594 @h='<strings.h>' \
595 re='\<(strn?casecmp|ffs(ll)?)\>' \
596 $(_sc_header_without_use)
597
598# Get the list of symbol names with this:
599# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
600_intprops_names = \
601 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
602 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
603 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
604_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
605# Prohibit the inclusion of intprops.h without an actual use.
606sc_prohibit_intprops_without_use:
607 @h='"intprops.h"' \
608 re='\<($(_intprops_syms_re)) *\(' \
609 $(_sc_header_without_use)
c84bdaf6 610
49114fd4
LC
611_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
612# Prohibit the inclusion of stddef.h without an actual use.
613sc_prohibit_stddef_without_use:
614 @h='<stddef.h>' \
615 re='\<($(_stddef_syms_re)) *\(' \
616 $(_sc_header_without_use)
617
3d458a81
AW
618# Don't include xfreopen.h unless you use one of its functions.
619sc_prohibit_xfreopen_without_use:
620 @h='"xfreopen.h"' re='\<xfreopen *\(' $(_sc_header_without_use)
621
c84bdaf6 622sc_obsolete_symbols:
a927b6c1
LC
623 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
624 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
625 $(_sc_search_regexp)
c84bdaf6
LC
626
627# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
628
629# Each nonempty ChangeLog line must start with a year number, or a TAB.
630sc_changelog:
a927b6c1
LC
631 @prohibit='^[^12 ]' \
632 in_vc_files='^ChangeLog$$' \
633 halt='found unexpected prefix in a ChangeLog' \
634 $(_sc_search_regexp)
c84bdaf6
LC
635
636# Ensure that each .c file containing a "main" function also
637# calls set_program_name.
638sc_program_name:
a927b6c1
LC
639 @require='set_program_name *\(m?argv\[0\]\);' \
640 in_vc_files='\.c$$' \
0f00f2c3 641 containing='\<main *(' \
a927b6c1
LC
642 halt='the above files do not call set_program_name' \
643 $(_sc_search_regexp)
c84bdaf6 644
0f00f2c3
LC
645# Ensure that each .c file containing a "main" function also
646# calls bindtextdomain.
647sc_bindtextdomain:
648 @require='bindtextdomain *\(' \
649 in_vc_files='\.c$$' \
650 containing='\<main *(' \
651 halt='the above files do not call bindtextdomain' \
652 $(_sc_search_regexp)
653
c84bdaf6
LC
654# Require that the final line of each test-lib.sh-using test be this one:
655# Exit $fail
656# Note: this test requires GNU grep's --label= option.
657Exit_witness_file ?= tests/test-lib.sh
658Exit_base := $(notdir $(Exit_witness_file))
659sc_require_test_exit_idiom:
660 @if test -f $(srcdir)/$(Exit_witness_file); then \
661 die=0; \
662 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
663 $$($(VC_LIST) tests)); do \
664 tail -n1 $$i | grep '^Exit .' > /dev/null \
665 && : || { die=1; echo $$i; } \
666 done; \
667 test $$die = 1 && \
668 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
669 echo 1>&2 'Exit something'; \
670 exit 1; } || :; \
671 fi
672
c84bdaf6 673sc_trailing_blank:
a927b6c1
LC
674 @prohibit='[ ]$$' \
675 halt='found trailing blank(s)' \
676 $(_sc_search_regexp)
c84bdaf6
LC
677
678# Match lines like the following, but where there is only one space
679# between the options and the description:
680# -D, --all-repeated[=delimit-method] print all duplicate lines\n
681longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
682sc_two_space_separator_in_usage:
a927b6c1
LC
683 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
684 halt='help2man requires at least two spaces between an option and its description'\
685 $(_sc_search_regexp)
c84bdaf6 686
3d458a81
AW
687# A regexp matching function names like "error" that may be used
688# to emit translatable messages.
689_gl_translatable_diag_func_re ?= error
690
c84bdaf6
LC
691# Look for diagnostics that aren't marked for translation.
692# This won't find any for which error's format string is on a separate line.
693sc_unmarked_diagnostics:
694 @grep -nE \
3d458a81
AW
695 '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
696 $$($(VC_LIST_EXCEPT)) \
dd7d0148 697 | grep -Ev '(_|ngettext ?)\(' && \
c84bdaf6
LC
698 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
699 exit 1; } || :
700
701# Avoid useless parentheses like those in this example:
702# #if defined (SYMBOL) || defined (SYM2)
703sc_useless_cpp_parens:
a927b6c1
LC
704 @prohibit='^# *if .*defined *\(' \
705 halt='found useless parentheses in cpp directive' \
706 $(_sc_search_regexp)
707
708# List headers for which HAVE_HEADER_H is always true, assuming you are
709# using the appropriate gnulib module. CAUTION: for each "unnecessary"
710# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
711# requires the gnulib module that guarantees the usability of that header.
712gl_assured_headers_ = \
713 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
714
715# Convert the list of names to upper case, and replace each space with "|".
716az_ = abcdefghijklmnopqrstuvwxyz
717AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
718gl_header_upper_case_or_ = \
719 $$($(gl_assured_headers_) \
720 | tr $(az_)/.- $(AZ_)___ \
721 | tr -s ' ' '|' \
722 )
723sc_prohibit_always_true_header_tests:
724 @or=$(gl_header_upper_case_or_); \
725 re="HAVE_($$or)_H"; \
726 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
727 halt=$$(printf '%s\n' \
728 'do not test the above HAVE_<header>_H symbol(s);' \
729 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
730 $(_sc_search_regexp)
731
732# ==================================================================
733gl_other_headers_ ?= \
734 intprops.h \
735 openat.h \
736 stat-macros.h
737
738# Perl -lne code to extract "significant" cpp-defined symbols from a
739# gnulib header file, eliminating a few common false-positives.
740gl_extract_significant_defines_ = \
741 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
742 && $$2 !~ /(?:rpl_|_used_without_)/\
743 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
744 and print $$1
745
746# Create a list of regular expressions matching the names
747# of macros that are guaranteed to be defined by parts of gnulib.
748define def_sym_regex
749 gen_h=$(gl_generated_headers_); \
750 (cd $(gnulib_dir)/lib; \
751 for f in *.in.h $(gl_other_headers_); do \
752 perl -lne '$(gl_extract_significant_defines_)' $$f; \
753 done; \
754 ) | sort -u \
755 | grep -Ev '^ATTRIBUTE_NORETURN' \
756 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
757endef
758
759# Don't define macros that we already get from gnulib header files.
760sc_prohibit_always-defined_macros:
761 @if test -d $(gnulib_dir); then \
762 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
763 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
764 esac; \
765 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
766 && { echo '$(ME): define the above via some gnulib .h file' \
767 1>&2; exit 1; } || :; \
768 fi
769# ==================================================================
770
771# Prohibit checked in backup files.
772sc_prohibit_backup_files:
773 @$(VC_LIST) | grep '~$$' && \
774 { echo '$(ME): found version controlled backup file' 1>&2; \
775 exit 1; } || :
c84bdaf6
LC
776
777# Require the latest GPL.
778sc_GPL_version:
a927b6c1
LC
779 @prohibit='either ''version [^3]' \
780 halt='GPL vN, N!=3' \
781 $(_sc_search_regexp)
c84bdaf6 782
61cd9dc9
LC
783# Require the latest GFDL. Two regexp, since some .texi files end up
784# line wrapping between 'Free Documentation License,' and 'Version'.
785_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
786sc_GFDL_version:
a927b6c1
LC
787 @prohibit='$(_GFDL_regexp)' \
788 halt='GFDL vN, N!=3' \
789 $(_sc_search_regexp)
790
0f00f2c3
LC
791# Don't use Texinfo's @acronym{}.
792# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
793texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
794sc_texinfo_acronym:
795 @prohibit='@acronym\{' \
796 in_vc_files='$(texinfo_suffix_re_)' \
797 halt='found use of Texinfo @acronym{}' \
798 $(_sc_search_regexp)
61cd9dc9 799
c84bdaf6
LC
800cvs_keywords = \
801 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
802
803sc_prohibit_cvs_keyword:
a927b6c1
LC
804 @prohibit='\$$($(cvs_keywords))\$$' \
805 halt='do not use CVS keyword expansion' \
806 $(_sc_search_regexp)
807
808# This Perl code is slightly obfuscated. Not only is each "$" doubled
809# because it's in a Makefile, but the $$c's are comments; we cannot
810# use "#" due to the way the script ends up concatenated onto one line.
811# It would be much more concise, and would produce better output (including
812# counts) if written as:
813# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
814# but that would be far less efficient, reading the entire contents
815# of each file, rather than just the last two bytes of each.
dd36ce77
MW
816# In addition, while the code below detects both blank lines and a missing
817# newline at EOF, the above detects only the former.
a927b6c1
LC
818#
819# This is a perl script that is expected to be the single-quoted argument
820# to a command-line "-le". The remaining arguments are file names.
dd36ce77
MW
821# Print the name of each file that ends in exactly one newline byte.
822# I.e., warn if there are blank lines (2 or more newlines), or if the
823# last byte is not a newline. However, currently we don't complain
824# about any file that contains exactly one byte.
a927b6c1
LC
825# Exit nonzero if at least one such file is found, otherwise, exit 0.
826# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
827#
828# Use this if you want to remove trailing empty lines from selected files:
829# perl -pi -0777 -e 's/\n\n+$/\n/' files...
830#
dd36ce77 831require_exactly_one_NL_at_EOF_ = \
a927b6c1
LC
832 foreach my $$f (@ARGV) \
833 { \
834 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
835 my $$p = sysseek (F, -2, 2); \
836 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
837 my $$last_two_bytes; \
838 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
839 close F; \
840 $$c = "ignore read failure"; \
dd36ce77
MW
841 $$p && ($$last_two_bytes eq "\n\n" \
842 || substr ($$last_two_bytes,1) ne "\n") \
843 and (print $$f), $$fail=1; \
a927b6c1
LC
844 } \
845 END { exit defined $$fail }
846sc_prohibit_empty_lines_at_EOF:
dd36ce77 847 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
dd7d0148
LC
848 || { echo '$(ME): empty line(s) or no newline at EOF' \
849 1>&2; exit 1; } || :
c84bdaf6
LC
850
851# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
852# This is a bit of a kludge, since it prevents use of the string
853# even in comments, but for now it does the job with no false positives.
854sc_prohibit_stat_st_blocks:
a927b6c1
LC
855 @prohibit='[.>]st_blocks' \
856 halt='do not use st_blocks; use ST_NBLOCKS' \
857 $(_sc_search_regexp)
c84bdaf6
LC
858
859# Make sure we don't define any S_IS* macros in src/*.c files.
860# They're already defined via gnulib's sys/stat.h replacement.
861sc_prohibit_S_IS_definition:
a927b6c1
LC
862 @prohibit='^ *# *define *S_IS' \
863 halt='do not define S_IS* macros; include <sys/stat.h>' \
864 $(_sc_search_regexp)
865
3d458a81
AW
866# Perl block to convert a match to FILE_NAME:LINENO:TEST,
867# that is shared by two definitions below.
868perl_filename_lineno_text_ = \
dd7d0148
LC
869 -e ' {' \
870 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
871 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
872 -e ' print "$$ARGV:$$n:$$v\n";' \
873 -e ' }'
874
3d458a81
AW
875prohibit_doubled_word_RE_ ?= \
876 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
877prohibit_doubled_word_ = \
878 -e 'while ($(prohibit_doubled_word_RE_))' \
879 $(perl_filename_lineno_text_)
880
dd7d0148
LC
881# Define this to a regular expression that matches
882# any filename:dd:match lines you want to ignore.
883# The default is to ignore no matches.
884ignore_doubled_word_match_RE_ ?= ^$$
885
886sc_prohibit_doubled_word:
887 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
888 | grep -vE '$(ignore_doubled_word_match_RE_)' \
889 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
890
3d458a81
AW
891# A regular expression matching undesirable combinations of words like
892# "can not"; this matches them even when the two words appear on different
893# lines, but not when there is an intervening delimiter like "#" or "*".
894prohibit_undesirable_word_seq_RE_ ?= \
895 /\bcan\s+not\b/gims
896prohibit_undesirable_word_seq_ = \
897 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
898 $(perl_filename_lineno_text_)
899# Define this to a regular expression that matches
900# any filename:dd:match lines you want to ignore.
901# The default is to ignore no matches.
902ignore_undesirable_word_sequence_RE_ ?= ^$$
903
904sc_prohibit_undesirable_word_seq:
905 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
906 $$($(VC_LIST_EXCEPT)) \
907 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
908 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
dd7d0148 909
a927b6c1
LC
910_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
911_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
912# Using test's -a and -o operators is not portable.
913# We prefer test over [, since the latter is spelled [[ in configure.ac.
914sc_prohibit_test_minus_ao:
915 @prohibit='(\<test| \[+) .+ -[ao] ' \
916 halt='$(_ptm1); $(_ptm2)' \
917 $(_sc_search_regexp)
c84bdaf6 918
0f00f2c3
LC
919# Avoid a test bashism.
920sc_prohibit_test_double_equal:
921 @prohibit='(\<test| \[+) .+ == ' \
922 containing='#! */bin/[a-z]*sh' \
923 halt='use "test x = x", not "test x =''= x"' \
924 $(_sc_search_regexp)
925
61cd9dc9
LC
926# Each program that uses proper_name_utf8 must link with one of the
927# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
928# The perl -0777 invocation below extracts the possibly-multi-line
929# definition of LDADD from the appropriate Makefile.am and exits 0
930# when it contains "ICONV".
c84bdaf6
LC
931sc_proper_name_utf8_requires_ICONV:
932 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
933 if test "x$$progs" != x; then \
934 fail=0; \
935 for p in $$progs; do \
936 dir=$$(dirname "$$p"); \
61cd9dc9
LC
937 perl -0777 \
938 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
939 $$dir/Makefile.am && continue; \
c84bdaf6
LC
940 base=$$(basename "$$p" .c); \
941 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
942 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
943 done; \
944 test $$fail = 1 && \
945 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
946 exit 1; } || :; \
947 fi
948
949# Warn about "c0nst struct Foo const foo[]",
950# but not about "char const *const foo" or "#define const const".
951sc_redundant_const:
a927b6c1
LC
952 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
953 halt='redundant "const" in declarations' \
954 $(_sc_search_regexp)
c84bdaf6
LC
955
956sc_const_long_option:
957 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
958 | grep -Ev 'const struct option|struct option const' && { \
959 echo 1>&2 '$(ME): add "const" to the above declarations'; \
960 exit 1; } || :
961
962NEWS_hash = \
963 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
964 $(srcdir)/NEWS \
61cd9dc9
LC
965 | perl -0777 -pe \
966 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
967 | md5sum - \
968 | sed 's/ .*//')
969
970# Ensure that we don't accidentally insert an entry into an old NEWS block.
971sc_immutable_NEWS:
972 @if test -f $(srcdir)/NEWS; then \
973 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
974 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
975 fi
976
977# Update the hash stored above. Do this after each release and
978# for any corrections to old entries.
979update-NEWS-hash: NEWS
980 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
981 $(srcdir)/cfg.mk
982
983# Ensure that we use only the standard $(VAR) notation,
984# not @...@ in Makefile.am, now that we can rely on automake
985# to emit a definition for each substituted variable.
dd7d0148
LC
986# However, there is still one case in which @VAR@ use is not just
987# legitimate, but actually required: when augmenting an automake-defined
988# variable with a prefix. For example, gettext uses this:
989# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
990# otherwise, makeinfo would put German or French (current locale)
991# navigation hints in the otherwise-English documentation.
992#
61cd9dc9
LC
993# Allow the package to add exceptions via a hook in cfg.mk;
994# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
995# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
996_makefile_at_at_check_exceptions ?=
997sc_makefile_at_at_check:
dd7d0148
LC
998 @perl -ne '/\@[A-Z_0-9]+\@/' \
999 -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
1000 -e ''$(_makefile_at_at_check_exceptions) \
c84bdaf6 1001 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
dd7d0148 1002 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
c84bdaf6
LC
1003 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1004
1cd4fffc 1005news-check: NEWS
9157d901
LC
1006 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
1007 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
1008 :; \
1009 else \
1cd4fffc 1010 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
1011 exit 1; \
1012 fi
1013
1014sc_makefile_TAB_only_indentation:
a927b6c1
LC
1015 @prohibit='^ [ ]{8}' \
1016 in_vc_files='akefile|\.mk$$' \
1017 halt='found TAB-8-space indentation' \
1018 $(_sc_search_regexp)
c84bdaf6
LC
1019
1020sc_m4_quote_check:
a927b6c1
LC
1021 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1022 in_vc_files='(^configure\.ac|\.m4)$$' \
1023 halt='quote the first arg to AC_DEF*' \
1024 $(_sc_search_regexp)
c84bdaf6
LC
1025
1026fix_po_file_diag = \
1027'you have changed the set of files with translatable diagnostics;\n\
1028apply the above patch\n'
1029
1030# Verify that all source files using _() are listed in po/POTFILES.in.
dd7d0148 1031po_file ?= $(srcdir)/po/POTFILES.in
3d458a81 1032generated_files ?= $(srcdir)/lib/*.[ch]
c84bdaf6
LC
1033sc_po_check:
1034 @if test -f $(po_file); then \
1035 grep -E -v '^(#|$$)' $(po_file) \
1036 | grep -v '^src/false\.c$$' | sort > $@-1; \
1037 files=; \
3d458a81 1038 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
c84bdaf6
LC
1039 test -r $$file || continue; \
1040 case $$file in \
1041 *.m4|*.mk) continue ;; \
1042 *.?|*.??) ;; \
1043 *) continue;; \
1044 esac; \
1045 case $$file in \
1046 *.[ch]) \
1047 base=`expr " $$file" : ' \(.*\)\..'`; \
1048 { test -f $$base.l || test -f $$base.y; } && continue;; \
1049 esac; \
1050 files="$$files $$file"; \
1051 done; \
1052 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
dd7d0148 1053 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
c84bdaf6
LC
1054 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1055 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1056 rm -f $@-1 $@-2; \
1057 fi
1058
1059# Sometimes it is useful to change the PATH environment variable
1060# in Makefiles. When doing so, it's better not to use the Unix-centric
1061# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1062msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1063sc_makefile_path_separator_check:
a927b6c1
LC
1064 @prohibit='PATH[=].*:' \
1065 in_vc_files='akefile|\.mk$$' \
1066 halt=$(msg) \
1067 $(_sc_search_regexp)
c84bdaf6
LC
1068
1069# Check that `make alpha' will not fail at the end of the process.
1070writable-files:
1071 if test -d $(release_archive_dir); then :; else \
1072 for file in $(distdir).tar.gz \
1073 $(release_archive_dir)/$(distdir).tar.gz; do \
1074 test -e $$file || continue; \
1075 test -w $$file \
1076 || { echo ERROR: $$file is not writable; fail=1; }; \
1077 done; \
1078 test "$$fail" && exit 1 || : ; \
1079 fi
1080
2e65b52f 1081v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
1082sample-test = tests/sample-test
1083texi = doc/$(PACKAGE).texi
1084# Make sure that the copyright date in $(v_etc_file) is up to date.
1085# Do the same for the $(sample-test) and the main doc/.texi file.
1086sc_copyright_check:
a927b6c1
LC
1087 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1088 in_files=$(v_etc_file) \
1089 halt='out of date copyright in $(v_etc_file); update it' \
1090 $(_sc_search_regexp)
1091 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1092 in_vc_files=$(sample-test) \
1093 halt='out of date copyright in $(sample-test); update it' \
1094 $(_sc_search_regexp)
1095 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1096 in_vc_files=$(texi) \
1097 halt='out of date copyright in $(texi); update it' \
1098 $(_sc_search_regexp)
1099
1100# If tests/help-version exists and seems to be new enough, assume that its
1101# use of init.sh and path_prepend_ is correct, and ensure that every other
1102# use of init.sh is identical.
1103# This is useful because help-version cross-checks prog --version
1104# with $(VERSION), which verifies that its path_prepend_ invocation
1105# sets PATH correctly. This is an inexpensive way to ensure that
1106# the other init.sh-using tests also get it right.
1107_hv_file ?= $(srcdir)/tests/help-version
1108_hv_regex_weak ?= ^ *\. .*/init\.sh"
1109_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1110sc_cross_check_PATH_usage_in_tests:
1111 @if test -f $(_hv_file); then \
1112 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1113 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1114 exit 0; }; \
1115 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1116 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1117 exit 1; }; \
1118 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1119 grep -LFx "$$good" \
1120 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1121 | grep . && \
1122 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1123 1>&2; exit 1; } || :; \
c84bdaf6
LC
1124 fi
1125
61cd9dc9
LC
1126# #if HAVE_... will evaluate to false for any non numeric string.
1127# That would be flagged by using -Wundef, however gnulib currently
1128# tests many undefined macros, and so we can't enable that option.
1129# So at least preclude common boolean strings as macro values.
1130sc_Wundef_boolean:
a927b6c1
LC
1131 @prohibit='^#define.*(yes|no|true|false)$$' \
1132 in_files='$(CONFIG_INCLUDE)' \
1133 halt='Use 0 or 1 for macro values' \
1134 $(_sc_search_regexp)
61cd9dc9
LC
1135
1136sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1137 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1138 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1139 halt=$$(printf '%s\n' \
1140 'the above files are vulnerable; beware of running' \
1141 ' "make dist*" rules, and upgrade to fixed automake' \
1142 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1143 $(_sc_search_regexp)
61cd9dc9 1144
c84bdaf6
LC
1145vc-diff-check:
1146 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1147 if test -s vc-diffs; then \
1148 cat vc-diffs; \
1149 echo "Some files are locally modified:" 1>&2; \
1150 exit 1; \
1151 else \
1152 rm vc-diffs; \
1153 fi
1154
c84bdaf6
LC
1155rel-files = $(DIST_ARCHIVES)
1156
1157gnulib_dir ?= $(srcdir)/gnulib
1158gnulib-version = $$(cd $(gnulib_dir) && git describe)
1159bootstrap-tools ?= autoconf,automake,gnulib
1160
61cd9dc9
LC
1161# If it's not already specified, derive the GPG key ID from
1162# the signed tag we've just applied to mark this release.
1163gpg_key_ID ?= \
1164 $$(git cat-file tag v$(VERSION) > .ann-sig \
1165 && gpgv .ann-sig - < /dev/null 2>&1 \
1166 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1167
a927b6c1 1168translation_project_ ?= coordinator@translationproject.org
3d458a81
AW
1169
1170# Make info-gnu the default only for a stable release.
1171ifeq ($(RELEASE_TYPE),stable)
1172 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1173 announcement_mail_headers_ ?= \
1174 To: info-gnu@gnu.org \
1175 Cc: $(announcement_Cc_) \
1176 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1177else
1178 announcement_Cc_ ?= $(translation_project_)
1179 announcement_mail_headers_ ?= \
1180 To: $(PACKAGE_BUGREPORT) \
1181 Cc: $(announcement_Cc_)
1182endif
a927b6c1 1183
c84bdaf6
LC
1184announcement: NEWS ChangeLog $(rel-files)
1185 @$(build_aux)/announce-gen \
a927b6c1 1186 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1187 --release-type=$(RELEASE_TYPE) \
1188 --package=$(PACKAGE) \
1189 --prev=$(PREV_VERSION) \
1190 --curr=$(VERSION) \
1191 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1192 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1193 --bootstrap-tools=$(bootstrap-tools) \
1194 --gnulib-version=$(gnulib-version) \
1195 --no-print-checksums \
1196 $(addprefix --url-dir=, $(url_dir_list))
1197
1198## ---------------- ##
1199## Updating files. ##
1200## ---------------- ##
1201
1202ftp-gnu = ftp://ftp.gnu.org/gnu
1203www-gnu = http://www.gnu.org
1204
dde9c5a4 1205upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1206emit_upload_commands:
1207 @echo =====================================
1208 @echo =====================================
1209 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1210 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1211 @echo " $(rel-files)"
61cd9dc9 1212 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1213 @echo =====================================
1214 @echo =====================================
1215
c84bdaf6
LC
1216define emit-commit-log
1217 printf '%s\n' 'post-release administrivia' '' \
1218 '* NEWS: Add header line for next release.' \
1219 '* .prev-version: Record previous version.' \
1220 '* cfg.mk (old_NEWS_hash): Auto-update.'
1221endef
1222
1223.PHONY: no-submodule-changes
1224no-submodule-changes:
1225 if test -d $(srcdir)/.git; then \
1226 diff=$$(cd $(srcdir) && git submodule -q foreach \
1227 git diff-index --name-only HEAD) \
1228 || exit 1; \
1229 case $$diff in '') ;; \
1230 *) echo '$(ME): submodule files are locally modified:'; \
1231 echo "$$diff"; exit 1;; esac; \
1232 else \
1233 : ; \
1234 fi
1235
49114fd4
LC
1236submodule-checks ?= no-submodule-changes public-submodule-commit
1237
1238# Ensure that each sub-module commit we're using is public.
1239# Without this, it is too easy to tag and release code that
1240# cannot be built from a fresh clone.
1241.PHONY: public-submodule-commit
1242public-submodule-commit:
1243 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1244 cd $(srcdir) && \
1245 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1246 = '$$(git merge-base origin $$sha1)' \
1247 || { echo '$(ME): found non-public submodule commit' >&2; \
1248 exit 1; }; \
1249 else \
1250 : ; \
1251 fi
1252# This rule has a high enough utility/cost ratio that it should be a
1253# dependent of "check" by default. However, some of us do occasionally
1254# commit a temporary change that deliberately points to a non-public
1255# submodule commit, and want to be able to use rules like "make check".
1256# In that case, run e.g., "make check gl_public_submodule_commit="
1257# to disable this test.
1258gl_public_submodule_commit ?= public-submodule-commit
1259check: $(gl_public_submodule_commit)
1260
c84bdaf6
LC
1261.PHONY: alpha beta stable
1262ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1263alpha beta stable: $(local-check) writable-files $(submodule-checks)
c84bdaf6
LC
1264 test $@ = stable \
1265 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1266 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1267 || :
1268 $(MAKE) vc-diff-check
1cd4fffc 1269 $(MAKE) news-check
c84bdaf6
LC
1270 $(MAKE) distcheck
1271 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1272 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1273 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1274
1275# Override this in cfg.mk if you follow different procedures.
1276release-prep-hook ?= release-prep
1277
0f00f2c3 1278gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1279.PHONY: release-prep
1280release-prep:
1281 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1282 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
3d458a81 1283 $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1284 if test -d $(release_archive_dir); then \
1285 ln $(rel-files) $(release_archive_dir); \
1286 chmod a-w $(rel-files); \
1287 fi
c84bdaf6
LC
1288 echo $(VERSION) > $(prev_version_file)
1289 $(MAKE) update-NEWS-hash
0f00f2c3 1290 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
c84bdaf6
LC
1291 $(emit-commit-log) > .ci-msg
1292 $(VC) commit -F .ci-msg -a
61cd9dc9 1293 rm .ci-msg
c84bdaf6 1294
a927b6c1
LC
1295# Override this with e.g., -s $(srcdir)/some_other_name.texi
1296# if the default $(PACKAGE)-derived name doesn't apply.
1297gendocs_options_ ?=
1298
c84bdaf6
LC
1299.PHONY: web-manual
1300web-manual:
1301 @test -z "$(manual_title)" \
1302 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1303 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1304 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1305 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1306 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1307 "$(PACKAGE_NAME) - $(manual_title)"
1308 @echo " *** Upload the doc/manual directory to web-cvs."
1309
1310# Code Coverage
1311
1312init-coverage:
1313 $(MAKE) $(AM_MAKEFLAGS) clean
1314 lcov --directory . --zerocounters
1315
1316COVERAGE_CCOPTS ?= "-g --coverage"
1317COVERAGE_OUT ?= doc/coverage
1318
1319build-coverage:
1320 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1321 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1322 mkdir -p $(COVERAGE_OUT)
1323 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1324 --capture
1325
1326gen-coverage:
1327 genhtml --output-directory $(COVERAGE_OUT) \
1328 $(COVERAGE_OUT)/$(PACKAGE).info \
1329 --highlight --frames --legend \
1330 --title "$(PACKAGE_NAME)"
1331
1332coverage: init-coverage build-coverage gen-coverage
1333
1334# Update gettext files.
1335PACKAGE ?= $(shell basename $(PWD))
1336PO_DOMAIN ?= $(PACKAGE)
1337POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1338PODIR ?= po
1339refresh-po:
1340 rm -f $(PODIR)/*.po && \
1341 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1342 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1343 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1344 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1345 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1346
a927b6c1 1347 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1348INDENT_SOURCES ?= $(C_SOURCES)
1349.PHONY: indent
1350indent:
1351 indent $(INDENT_SOURCES)
a927b6c1 1352 indent $(INDENT_SOURCES)
c84bdaf6
LC
1353
1354# If you want to set UPDATE_COPYRIGHT_* environment variables,
1355# put the assignments in this variable.
1356update-copyright-env ?=
1357
1358# Run this rule once per year (usually early in January)
1359# to update all FSF copyright year lists in your project.
1360# If you have an additional project-specific rule,
1361# add it in cfg.mk along with a line 'update-copyright: prereq'.
1362# By default, exclude all variants of COPYING; you can also
1363# add exemptions (such as ChangeLog..* for rotated change logs)
1364# in the file .x-update-copyright.
1365.PHONY: update-copyright
1366update-copyright:
1367 grep -l -w Copyright \
1368 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1369 | $(update-copyright-env) xargs $(build_aux)/$@
3d458a81
AW
1370
1371# This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1372# overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1373
1374# NOTE: to override any _gl_TS_* default value, you must
1375# define the variable(s) using "export" in cfg.mk.
1376_gl_TS_dir ?= src
1377
1378ALL_RECURSIVE_TARGETS += sc_tight_scope
1379sc_tight_scope: tight-scope.mk
1380 @if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1381 > /dev/null \
1382 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1383 > /dev/null 2>&1; then \
1384 echo '$(ME): skipping $@'; \
1385 else \
1386 $(MAKE) -s -C $(_gl_TS_dir) \
1387 -f Makefile \
1388 -f $(abs_top_srcdir)/cfg.mk \
1389 -f $(abs_top_builddir)/$< \
1390 _gl_tight_scope \
1391 || fail=1; \
1392 fi
1393 @rm -f $<
1394
1395tight-scope.mk: $(ME)
1396 @rm -f $@ $@-t
1397 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
1398 @chmod a=r $@-t && mv $@-t $@
1399
1400ifeq (a,b)
1401# TS-start
1402
1403# Most functions should have static scope.
1404# Any that don't must be marked with `extern', but `main'
1405# and `usage' are exceptions: they're always extern, but
1406# do not need to be marked. Symbols matching `__.*' are
1407# reserved by the compiler, so are automatically excluded below.
1408_gl_TS_unmarked_extern_functions ?= main usage
1409_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) +\(/
1410
1411# If your project uses a macro like "XTERN", then put
1412# the following in cfg.mk to override this default:
1413# export _gl_TS_extern = extern|XTERN
1414_gl_TS_extern ?= extern
1415
1416# The second nm|grep checks for file-scope variables with `extern' scope.
1417# Without gnulib's progname module, you might put program_name here.
1418# Symbols matching `__.*' are reserved by the compiler,
1419# so are automatically excluded below.
1420_gl_TS_unmarked_extern_vars ?=
1421
1422# NOTE: the _match variables are perl expressions -- not mere regular
1423# expressions -- so that you can extend them to match other patterns
1424# and easily extract matched variable names.
1425# For example, if your project declares some global variables via
1426# a macro like this: GLOBAL(type, var_name, initializer), then you
1427# can override this definition to automatically extract those names:
1428# export _gl_TS_var_match = \
1429# /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1430_gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1431
1432# The names of object files in (or relative to) $(_gl_TS_dir).
1433_gl_TS_obj_files ?= *.$(OBJEXT)
1434
1435# Files in which to search for the one-line style extern declarations.
1436# $(_gl_TS_dir)-relative.
1437_gl_TS_headers ?= $(noinst_HEADERS)
1438
1439.PHONY: _gl_tight_scope
1440_gl_tight_scope: $(bin_PROGRAMS)
1441 t=exceptions-$$$$; \
1442 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1443 for sig in 1 2 3 13 15; do \
1444 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1445 done; \
1446 src=`for f in $(SOURCES); do \
1447 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1448 hdr=`for f in $(_gl_TS_headers); do \
1449 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1450 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1451 grep -h -A1 '^extern .*[^;]$$' $$src \
1452 | grep -vE '^(extern |--)' | sed 's/ .*//'; \
1453 perl -lne \
1454 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1455 ) | sort -u > $$t; \
1456 nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1457 && { echo the above functions should have static scope >&2; \
1458 exit 1; } || : ; \
1459 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
1460 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1461 ) | sort -u > $$t; \
1462 nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
1463 | sort -u | grep -Ev -f $$t \
1464 && { echo the above variables should have static scope >&2; \
1465 exit 1; } || :
1466# TS-end
1467endif